#!/usr/bin/perl -w
use Test; 
BEGIN { plan tests => 9 }
BEGIN { unshift @INC, "../blib/lib" }
use POWER::lib;

$TempFile = "tmp.dat";

$ret    = Echo($TempFile);
ok($ret, undef,             "error");
ok(0+$!, 2,                 "error code: no file");

system("touch $TempFile");
$ret    = Echo("<$TempFile");
ok($ret, undef,             "error");
ok(0+$!, 9,                 "error code: bad file");
unlink $TempFile;

@in     = ();
Echo(">$TempFile", @in);
@out    = Cat($TempFile);
ok(@out, 0,                 "empty list");

@in     = ("line1", "line2", "line3");
Echo(">$TempFile", @in);
@out    = Cat($TempFile);
ok(@out, 3,                 "lines without CR, check count");
$in     = join "", map {"$_\n"} @in;
$out    = join "", @out;
ok($in, $out,               "lines without CR, check content");

@in     = ("line1", "line2\n", "line3");
Echo(">$TempFile", @in);
@out    = Cat($TempFile);
ok(@out, 2,                 "lines with CR, check count");
$in     = join "", @in;
$out    = join "", @out;
ok($in, $out,               "lines with CR, check content");

unlink $TempFile;

