#!/usr/bin/perl -w
use Test; 
BEGIN { plan tests => 9 }
BEGIN { unshift @INC, "../blib/lib" }
use POWER::lib;

$out    = UpdateHash();
ok(Diff($out, {}), 1,       "without params");

$in     = {};
$out    = UpdateHash($in);
ok(Diff($in, $out), 1,      "empty hash");
ok("$in", "$out",           "same hash");

$out    = UpdateHash($in, {});
ok(Diff($in, $out), 1,      "don't change");

$wait   = {
    s1=>1, s2=>2, a0=>[], a1=>[1], a2=>[2,3],
    h0=>{}, h1=>{qwe=>"asd"}, h2=>{1=>2,3=>4}
    };
$out    = UpdateHash({}, { s1 => 1, s2 => 2 });
UpdateHash($out, { a0 => [], a1 => [1], a2 => [2, 3] });
UpdateHash($out, { h0 => {}, h1 => {qwe=>"asd"}, h2 => {1=>2, 3=>4} });
ok(Diff($out, $wait), 1,    "3 updates");

$wait->{a2} = [4,5];
$wait->{h2}{3} = 44;
$out    = UpdateHash($out, { a2 => [4, 5], h2 => {3=>44} });
ok(Diff($out, $wait), 1,    "replace array and update hash");

$wait->{a1} = {hash=>"new"};
UpdateHash($out, { a1 => {hash=>"new"} });
ok(Diff($out, $wait), 1,    "replace array with hash");

$wait->{h1} = [15];
UpdateHash($out, { h1 => [15] });
ok(Diff($out, $wait), 1,    "replace hash with array");

# from documentation

$main = {};
UpdateHash( $main, {
    PARAM1 => "value1",
    PARAM2 => 15,
    });
UpdateHash( $main, {
    PARAM2 => 123,
    PARAM3 => {
        DATA1 => "value31",
        DATA2 => "value32",
        },
    });
UpdateHash( $main, {
    PARAM3 => {
        DATA2 => "newvalue32",
        },
    });
$wait = {
    PARAM1 => "value1",
    PARAM2 => 123,
    PARAM3 => {
        DATA1 => "value31",
        DATA2 => "newvalue32",
        },
    };
ok(Diff($main, $wait), 1,   "complex example");

