#!/usr/bin/perl -w
BEGIN { unshift @INC, "./blib/lib" }
use POWER::lib qw(time);

# POWER::lib loading

$t0 = time();
system("perl -e ''");
$t1 = time();
system("perl -e 'BEGIN { unshift \@INC, \"./blib/lib\" } use POWER::lib;'");
$t2 = time();
system("perl -e 'BEGIN { unshift \@INC, \"./blib/lib\" } use POWER::lib qw(time);'");
$t3 = time();
system("perl -e 'BEGIN { unshift \@INC, \"./blib/lib\" } use Time::HiRes qw(time);'");
$t4 = time();
printf "%.5f use POWER::lib;\n", (($t2-$t1)-($t1-$t0));
printf "%.5f use POWER::lib qw(time);\n", (($t3-$t2)-($t1-$t0));
printf "%.5f use Time::HiRes qw(time);\n", (($t4-$t3)-($t1-$t0));

# POWER::lib::time() vs Time::HiRes::time()

$count = 10000;
system("perl ./test.time $count");

eval "use Time::HiRes;";
if ($@) {
    print "Time::HiRes not found, skipping\n";
} else {
    $t0 = time();
    $t = time() for 1 .. $count;
    $t1 = time();
    printf "%.5f $count of POWER::lib::time() with Time::HiRes\n", $t1-$t0;

    $t0 = Time::HiRes::time();
    $t = Time::HiRes::time() for 1 .. $count;
    $t1 = Time::HiRes::time();
    printf "%.5f $count of Time::HiRes::time()\n", $t1-$t0;
}

